//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class OpenMMVectorVec3 : global::System.IDisposable, global::System.Collections.IEnumerable
    , global::System.Collections.Generic.IEnumerable<Vec3>
 {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal OpenMMVectorVec3(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(OpenMMVectorVec3 obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~OpenMMVectorVec3() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_OpenMMVectorVec3(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }

  public OpenMMVectorVec3(global::System.Collections.ICollection c) : this() {
    if (c == null)
      throw new global::System.ArgumentNullException("c");
    foreach (Vec3 element in c) {
      this.Add(element);
    }
  }

  public bool IsFixedSize {
    get {
      return false;
    }
  }

  public bool IsReadOnly {
    get {
      return false;
    }
  }

  public Vec3 this[int index]  {
    get {
      return getitem(index);
    }
    set {
      setitem(index, value);
    }
  }

  public int Capacity {
    get {
      return (int)capacity();
    }
    set {
      if (value < size())
        throw new global::System.ArgumentOutOfRangeException("Capacity");
      reserve((uint)value);
    }
  }

  public int Count {
    get {
      return (int)size();
    }
  }

  public bool IsSynchronized {
    get {
      return false;
    }
  }

  public void CopyTo(Vec3[] array)
  {
    CopyTo(0, array, 0, this.Count);
  }

  public void CopyTo(Vec3[] array, int arrayIndex)
  {
    CopyTo(0, array, arrayIndex, this.Count);
  }

  public void CopyTo(int index, Vec3[] array, int arrayIndex, int count)
  {
    if (array == null)
      throw new global::System.ArgumentNullException("array");
    if (index < 0)
      throw new global::System.ArgumentOutOfRangeException("index", "Value is less than zero");
    if (arrayIndex < 0)
      throw new global::System.ArgumentOutOfRangeException("arrayIndex", "Value is less than zero");
    if (count < 0)
      throw new global::System.ArgumentOutOfRangeException("count", "Value is less than zero");
    if (array.Rank > 1)
      throw new global::System.ArgumentException("Multi dimensional array.", "array");
    if (index+count > this.Count || arrayIndex+count > array.Length)
      throw new global::System.ArgumentException("Number of elements to copy is too large.");
    for (int i=0; i<count; i++)
      array.SetValue(getitemcopy(index+i), arrayIndex+i);
  }

  global::System.Collections.Generic.IEnumerator<Vec3> global::System.Collections.Generic.IEnumerable<Vec3>.GetEnumerator() {
    return new OpenMMVectorVec3Enumerator(this);
  }

  global::System.Collections.IEnumerator global::System.Collections.IEnumerable.GetEnumerator() {
    return new OpenMMVectorVec3Enumerator(this);
  }

  public OpenMMVectorVec3Enumerator GetEnumerator() {
    return new OpenMMVectorVec3Enumerator(this);
  }

  // Type-safe enumerator
  /// Note that the IEnumerator documentation requires an InvalidOperationException to be thrown
  /// whenever the collection is modified. This has been done for changes in the size of the
  /// collection but not when one of the elements of the collection is modified as it is a bit
  /// tricky to detect unmanaged code that modifies the collection under our feet.
  public sealed class OpenMMVectorVec3Enumerator : global::System.Collections.IEnumerator
    , global::System.Collections.Generic.IEnumerator<Vec3>
  {
    private OpenMMVectorVec3 collectionRef;
    private int currentIndex;
    private object currentObject;
    private int currentSize;

    public OpenMMVectorVec3Enumerator(OpenMMVectorVec3 collection) {
      collectionRef = collection;
      currentIndex = -1;
      currentObject = null;
      currentSize = collectionRef.Count;
    }

    // Type-safe iterator Current
    public Vec3 Current {
      get {
        if (currentIndex == -1)
          throw new global::System.InvalidOperationException("Enumeration not started.");
        if (currentIndex > currentSize - 1)
          throw new global::System.InvalidOperationException("Enumeration finished.");
        if (currentObject == null)
          throw new global::System.InvalidOperationException("Collection modified.");
        return (Vec3)currentObject;
      }
    }

    // Type-unsafe IEnumerator.Current
    object global::System.Collections.IEnumerator.Current {
      get {
        return Current;
      }
    }

    public bool MoveNext() {
      int size = collectionRef.Count;
      bool moveOkay = (currentIndex+1 < size) && (size == currentSize);
      if (moveOkay) {
        currentIndex++;
        currentObject = collectionRef[currentIndex];
      } else {
        currentObject = null;
      }
      return moveOkay;
    }

    public void Reset() {
      currentIndex = -1;
      currentObject = null;
      if (collectionRef.Count != currentSize) {
        throw new global::System.InvalidOperationException("Collection modified.");
      }
    }

    public void Dispose() {
        currentIndex = -1;
        currentObject = null;
    }
  }

  public void Clear() {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_Clear(swigCPtr);
  }

  public void Add(Vec3 x) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_Add(swigCPtr, Vec3.getCPtr(x));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  private uint size() {
    uint ret = OpenMMSwigPINVOKE.OpenMMVectorVec3_size(swigCPtr);
    return ret;
  }

  private uint capacity() {
    uint ret = OpenMMSwigPINVOKE.OpenMMVectorVec3_capacity(swigCPtr);
    return ret;
  }

  private void reserve(uint n) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_reserve(swigCPtr, n);
  }

  public OpenMMVectorVec3() : this(OpenMMSwigPINVOKE.new_OpenMMVectorVec3__SWIG_0(), true) {
  }

  public OpenMMVectorVec3(OpenMMVectorVec3 other) : this(OpenMMSwigPINVOKE.new_OpenMMVectorVec3__SWIG_1(OpenMMVectorVec3.getCPtr(other)), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public OpenMMVectorVec3(int capacity) : this(OpenMMSwigPINVOKE.new_OpenMMVectorVec3__SWIG_2(capacity), true) {
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  private Vec3 getitemcopy(int index) {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.OpenMMVectorVec3_getitemcopy(swigCPtr, index), true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  private Vec3 getitem(int index) {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.OpenMMVectorVec3_getitem(swigCPtr, index), false);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  private void setitem(int index, Vec3 val) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_setitem(swigCPtr, index, Vec3.getCPtr(val));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void AddRange(OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_AddRange(swigCPtr, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public OpenMMVectorVec3 GetRange(int index, int count) {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.OpenMMVectorVec3_GetRange(swigCPtr, index, count);
    OpenMMVectorVec3 ret = (cPtr == global::System.IntPtr.Zero) ? null : new OpenMMVectorVec3(cPtr, true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void Insert(int index, Vec3 x) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_Insert(swigCPtr, index, Vec3.getCPtr(x));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void InsertRange(int index, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_InsertRange(swigCPtr, index, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void RemoveAt(int index) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_RemoveAt(swigCPtr, index);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void RemoveRange(int index, int count) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_RemoveRange(swigCPtr, index, count);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public static OpenMMVectorVec3 Repeat(Vec3 value, int count) {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.OpenMMVectorVec3_Repeat(Vec3.getCPtr(value), count);
    OpenMMVectorVec3 ret = (cPtr == global::System.IntPtr.Zero) ? null : new OpenMMVectorVec3(cPtr, true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public void Reverse() {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_Reverse__SWIG_0(swigCPtr);
  }

  public void Reverse(int index, int count) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_Reverse__SWIG_1(swigCPtr, index, count);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

  public void SetRange(int index, OpenMMVectorVec3 values) {
    OpenMMSwigPINVOKE.OpenMMVectorVec3_SetRange(swigCPtr, index, OpenMMVectorVec3.getCPtr(values));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
  }

}

}
